#coding=utf-8
import os
import datetime
import pandas as pd
from LIB.BACKEND import DBManager, Log
from LIB.MIDDLE import SignalMonitor
from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker
import time, datetime
import traceback
from LIB.MIDDLE.soh import NCMSoh_20210716 as NCMSoh
from LIB.MIDDLE.soh import LFPSoh_20210711 as LFPSoh
from urllib import parse

dbManager = DBManager.DBManager()
if __name__ == "__main__":
    # 数据库配置
    host = 'rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
    port = 3306
    user = 'qx_cas'
    password = parse.quote_plus('Qx@123456')
    database = 'qx_cas'

    db_engine = create_engine(
        "mysql+pymysql://{}:{}@{}:{}/{}?charset=utf8".format(
            user, password, host, port, database
        ))
    print("mysql+pymysql://{}:{}@{}:{}/{}?charset=utf8".format(
            user, password, host, port, database
        ))
    DbSession = sessionmaker(bind=db_engine)
    
    # 日志配置
    log = Log.Mylog(log_name='signal_monitor', log_level = 'info')
    log.set_file_hl(file_name='info.log', log_level='info')
    log.set_file_hl(file_name='error.log', log_level='error')
    logger = log.get_logger()

    logger.info("pid is + {}".format(os.getpid()))

    SNdata_6040 = pd.read_excel('骑享资产梳理-20210621.xlsx', sheet_name='6040骑享')
    SNdata_6060 = pd.read_excel('骑享资产梳理-20210621.xlsx', sheet_name='6060')
    SNnums_6060=SNdata_6060['SN号']
    SNnums_6040=SNdata_6040['SN号']
    now_time=datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    now_time=datetime.datetime.strptime(now_time,'%Y-%m-%d %H:%M:%S')
    start_time=now_time-datetime.timedelta(days=30)
    end_time=str(now_time)
    start_time=str(start_time)

    for sn in SNnums_6040.tolist():
        try:
            res = NCMSoh.cal_soh(sn, end_time, start_time)
            if not res.empty:
                res.columns = ['time', 'sn', 'bms_soh', 'soh', 'soh_err']
                res.to_sql("soh_result",con=db_engine, if_exists="append",index=False)
        except:
            logger.error(traceback.format_exc)
            logger.error(u"{} ：{},{} 任务运行错误".format(sn,start_time,end_time), exc_info=True)

    for sn in SNnums_6060.tolist():
        try:
            res = LFPSoh.cal_soh(sn, end_time, start_time)
            if not res.empty:
                res.columns = ['time', 'sn', 'bms_soh', 'soh', 'soh_err']
                res.to_sql("soh_result",con=db_engine, if_exists="append",index=False)
        except:
            logger.error(traceback.format_exc)
            logger.error(u"{} ：{},{} 任务运行错误".format(sn,start_time,end_time), exc_info=True)

